/*
 * W A R N I N G:
 *
 *    this file has been preprocessed
 *    any changes must be made to the original file
 */

/*
 * vgrammar.c - includes and macros for building the parse tree
 */


/*
 * Icon configuration file for the Sun 4
 */



/*
 * NOTE: these %token declarations are generated
 *  automatically by mktoktab from tokens.txt and 
 *  op.txt.
 */

/* primitive tokens */

%token	IDENT
%token	INTLIT
%token	REALLIT
%token	STRINGLIT
%token	CSETLIT
%token	EOFX

/* reserved words */

%token	BREAK       /* break     */
%token	BY          /* by        */
%token	CASE        /* case      */
%token	CREATE      /* create    */
%token	DEFAULT     /* default   */
%token	DO          /* do        */
%token	ELSE        /* else      */
%token	END         /* end       */
%token	EVERY       /* every     */
%token	FAIL        /* fail      */
%token	GLOBAL      /* global    */
%token	IF          /* if        */
%token	INITIAL     /* initial   */
%token	INVOCABLE   /* invocable */
%token	LINK        /* link      */
%token	LOCAL       /* local     */
%token	NEXT        /* next      */
%token	NOT         /* not       */
%token	OF          /* of        */
%token	PROCEDURE   /* procedure */
%token	RECORD      /* record    */
%token	REPEAT      /* repeat    */
%token	RETURN      /* return    */
%token	STATIC      /* static    */
%token	SUSPEND     /* suspend   */
%token	THEN        /* then      */
%token	TO          /* to        */
%token	UNTIL       /* until     */
%token	WHILE       /* while     */

/* operators */

%token	BANG        /* !         */
%token	MOD         /* %         */
%token	AUGMOD      /* %:=       */
%token	AND         /* &         */
%token	AUGAND      /* &:=       */
%token	STAR        /* *         */
%token	AUGSTAR     /* *:=       */
%token	INTER       /* **        */
%token	AUGINTER    /* **:=      */
%token	PLUS        /* +         */
%token	AUGPLUS     /* +:=       */
%token	UNION       /* ++        */
%token	AUGUNION    /* ++:=      */
%token	MINUS       /* -         */
%token	AUGMINUS    /* -:=       */
%token	DIFF        /* --        */
%token	AUGDIFF     /* --:=      */
%token	DOT         /* .         */
%token	SLASH       /* /         */
%token	AUGSLASH    /* /:=       */
%token	ASSIGN      /* :=        */
%token	SWAP        /* :=:       */
%token	NMLT        /* <         */
%token	AUGNMLT     /* <:=       */
%token	REVASSIGN   /* <-        */
%token	REVSWAP     /* <->       */
%token	SLT         /* <<        */
%token	AUGSLT      /* <<:=      */
%token	SLE         /* <<=       */
%token	AUGSLE      /* <<=:=     */
%token	NMLE        /* <=        */
%token	AUGNMLE     /* <=:=      */
%token	NMEQ        /* =         */
%token	AUGNMEQ     /* =:=       */
%token	SEQ         /* ==        */
%token	AUGSEQ      /* ==:=      */
%token	EQUIV       /* ===       */
%token	AUGEQUIV    /* ===:=     */
%token	NMGT        /* >         */
%token	AUGNMGT     /* >:=       */
%token	NMGE        /* >=        */
%token	AUGNMGE     /* >=:=      */
%token	SGT         /* >>        */
%token	AUGSGT      /* >>:=      */
%token	SGE         /* >>=       */
%token	AUGSGE      /* >>=:=     */
%token	QMARK       /* ?         */
%token	AUGQMARK    /* ?:=       */
%token	AT          /* @         */
%token	AUGAT       /* @:=       */
%token	BACKSLASH   /* \         */
%token	CARET       /* ^         */
%token	AUGCARET    /* ^:=       */
%token	BAR         /* |         */
%token	CONCAT      /* ||        */
%token	AUGCONCAT   /* ||:=      */
%token	LCONCAT     /* |||       */
%token	AUGLCONCAT  /* |||:=     */
%token	TILDE       /* ~         */
%token	NMNE        /* ~=        */
%token	AUGNMNE     /* ~=:=      */
%token	SNE         /* ~==       */
%token	AUGSNE      /* ~==:=     */
%token	NEQUIV      /* ~===      */
%token	AUGNEQUIV   /* ~===:=    */
%token	LPAREN      /* (         */
%token	RPAREN      /* )         */
%token	PCOLON      /* +:        */
%token	COMMA       /* ,         */
%token	MCOLON      /* -:        */
%token	COLON       /* :         */
%token	SEMICOL     /* ;         */
%token	LBRACK      /* [         */
%token	RBRACK      /* ]         */
%token	LBRACE      /* {*/
%token	RBRACE      /* }         */


%{
/*
 * These commented directives are passed through the first application
 * of cpp, then turned into real includes in tgram.g by fixgram.icn.
 */
#include "../h/gsupport.h"
#include "../h/lexdef.h"
#include "tproto.h"
#include "tglobals.h"
#include "tsym.h"
#include "tree.h"
#include "keyword.h"
#undef YYSTYPE
#define YYSTYPE nodeptr
#define YYMAXDEPTH 500

extern int fncargs[];
int idflag;
int id_cnt;

nodeptr q();
nodeptr cat();
nodeptr quote();



nodeptr proc(), recrd(), globl(), link(), invoc();



%}

%%

/*
 * grammar.h -- Yacc grammar for Icon, Version 8.8.
 *
 * This file is combined with other files to make the Yacc input for
 * building icont, iconc, and variant translators.
 *
 * Any modifications to this grammar will require corresponding changes to
 * parserr.h, icont/tgrammar.c, iconc/cgrammar.c, and vtran/vtfiles/ident.c.
 */

program	: decls EOFX {$$ = (nodeptr)printf("end\n");} ;

decls	: ;	
	| decls decl ;

decl	: record {if (!nocode) treeprt($1); treefree($1);} ;
	| proc {if (!nocode) treeprt($1); treefree($1);} ;
	| global {if (!nocode) treeprt($1); treefree($1);} ;
	| link {if (!nocode) treeprt($1); treefree($1);} ;
        | invocable {if (!nocode) treeprt($1); treefree($1);};

invocable : INVOCABLE invoclist {$$ = invoc($2);} ;

invoclist : invocop;
	  | invoclist COMMA invocop {$$ = cat(3,$1,$2,$3);} ;

invocop  : IDENT {$$ = $1;} ;
	 | STRINGLIT {$$ = quote($1, "\"");} ;
	 | STRINGLIT COLON INTLIT {$$ = cat(3,quote($1, "\""),$2,$3);} ;

link	: LINK lnklist {$$ = link($2);} ;

lnklist	: lnkfile ;
	| lnklist COMMA lnkfile {$$ = cat(3,$1,$2,$3);} ;

lnkfile	: IDENT {$$ = cat(3,q("\""),$1,q("\""));} ;
	| STRINGLIT {$$ = cat(3,q("\"\\\""),$1,q("\\\"\""));} ;

global	: GLOBAL {$$ = q("");} idlist  {$$ = globl($3);} ;

record	: RECORD IDENT {$$ = q("");} LPAREN fldlist RPAREN {
		$$ = recrd($2,$5);
		} ;

fldlist	: {$$ = q("");} ;
	| idlist {$$ = $1;} ;

proc	: prochead SEMICOL locals initial procbody END {
		$$ = proc($1,$3,$4,$5);
		} ;

prochead: PROCEDURE IDENT {$$ = q("");} LPAREN arglist RPAREN {
		$$ = cat(5,q("Proc_(\""),$2,q("\","),$5,q(")"));
		} ;

arglist	: {$$ = q("");} ;
	| idlist {$$ = $1;} ;
	| idlist LBRACK RBRACK {$$ = cat(2,$1,q(",\"[]\""));} ;


idlist	: IDENT {
		$$ = cat(3,q("Arg_(\""),$1,q("\")"));
		} ;
	| idlist COMMA IDENT {
		$$ = cat(4,$1,q(",\""),$3,q("\""));
		} ;

locals	: {$$ = q("");} ;
	| locals retention idlist SEMICOL {$$ = cat(4,$1,$2,$3,q(")\n"));} ;

retention: LOCAL {$$ = q("Local_(");} ;
	| STATIC {$$ = q("Static_(");} ;

initial	: {$$ = q("");} ;
	| INITIAL expr SEMICOL {$$ = cat(3,q("Initial_("),$2,q(")"));} ;

procbody: {$$ = q("");} ;
	| nexpr SEMICOL procbody {$$ = cat(3,$1,q(",\n"),$3);} ;

nexpr	: {$$ = q("Null_()");} ;
	| expr ;

expr	: expr1a ;
	| expr AND expr1a	{$$ = cat(5,q("Bamper_("),$1,q(","),$3,q(")"));} ;

expr1a	: expr1 ;
	| expr1a QMARK expr1	{$$ = cat(5,q("Scan_("),$1,q(","),$3,q(")"));} ;

expr1	: expr2 ;
	| expr2 SWAP expr1 {$$ = cat(5,q("Asgnop_(\":=:\","),$1,q(","),$3,q(")"));} ;
	| expr2 ASSIGN expr1 {$$ = cat(5,q("Asgnop_(\":=\","),$1,q(","),$3,q(")"));} ;
	| expr2 REVSWAP expr1 {$$ = cat(5,q("Asgnop_(\"<->\","),$1,q(","),$3,q(")"));} ;
	| expr2 REVASSIGN expr1 {$$ = cat(5,q("Asgnop_(\"<-\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGCONCAT expr1 {$$ = cat(5,q("Asgnop_(\"||:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGLCONCAT expr1 {$$ = cat(5,q("Asgnop_(\"|||:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGDIFF expr1 {$$ = cat(5,q("Asgnop_(\"--:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGUNION expr1 {$$ = cat(5,q("Asgnop_(\"++:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGPLUS expr1 {$$ = cat(5,q("Asgnop_(\"+:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGMINUS expr1 {$$ = cat(5,q("Asgnop_(\"-:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSTAR expr1 {$$ = cat(5,q("Asgnop_(\"*:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGINTER expr1 {$$ = cat(5,q("Asgnop_(\"**:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSLASH expr1 {$$ = cat(5,q("Asgnop_(\"/:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGMOD expr1 {$$ = cat(5,q("Asgnop_(\"%:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGCARET expr1 {$$ = cat(5,q("Asgnop_(\"^:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNMEQ expr1 {$$ = cat(5,q("Asgnop_(\"=:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGEQUIV expr1 {$$ = cat(5,q("Asgnop_(\"===:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNMGE expr1 {$$ = cat(5,q("Asgnop_(\">=:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNMGT expr1 {$$ = cat(5,q("Asgnop_(\">:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNMLE expr1 {$$ = cat(5,q("Asgnop_(\"<=:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNMLT expr1 {$$ = cat(5,q("Asgnop_(\"<:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNMNE expr1 {$$ = cat(5,q("Asgnop_(\"~=:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGNEQUIV expr1 {$$ = cat(5,q("Asgnop_(\"~===:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSEQ expr1 {$$ = cat(5,q("Asgnop_(\"==:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSGE expr1 {$$ = cat(5,q("Asgnop_(\">>=:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSGT expr1 {$$ = cat(5,q("Asgnop_(\">>:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSLE expr1 {$$ = cat(5,q("Asgnop_(\"<<=:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSLT expr1 {$$ = cat(5,q("Asgnop_(\"<<:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGSNE expr1 {$$ = cat(5,q("Asgnop_(\"~==:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGQMARK expr1 {$$ = cat(5,q("Augscan_("),$1,q(","),$3,q(")"));} ;
	| expr2 AUGAND expr1 {$$ = cat(5,q("Asgnop_(\"&:=\","),$1,q(","),$3,q(")"));} ;
	| expr2 AUGAT expr1 {$$ = cat(5,q("Asgnop_(\"@:=\","),$1,q(","),$3,q(")"));} ;

expr2	: expr3 ;
	| expr2 TO expr3 {$$ = cat(5,q("To_("),$1,q(","),$3,q(")"));} ;
	| expr2 TO expr3 BY expr3 {$$ = cat(7,q("To_By_("),$1,q(","),$3,q(","),$5,q(")"));} ;

expr3	: expr4 ;
	| expr4 BAR expr3 {$$ = cat(5,q("Alt_("),$1,q(","),$3,q(")"));} ;

expr4	: expr5 ;
	| expr4 SEQ expr5 {$$ = cat(5,q("Binop_(\"==\","),$1,q(","),$3,q(")"));} ;
	| expr4 SGE expr5 {$$ = cat(5,q("Binop_(\">>=\","),$1,q(","),$3,q(")"));} ;
	| expr4 SGT expr5 {$$ = cat(5,q("Binop_(\">>\","),$1,q(","),$3,q(")"));} ;
	| expr4 SLE expr5 {$$ = cat(5,q("Binop_(\"<<=\","),$1,q(","),$3,q(")"));} ;
	| expr4 SLT expr5 {$$ = cat(5,q("Binop_(\"<<\","),$1,q(","),$3,q(")"));} ;
	| expr4 SNE expr5 {$$ = cat(5,q("Binop_(\"~==\","),$1,q(","),$3,q(")"));} ;
	| expr4 NMEQ expr5 {$$ = cat(5,q("Binop_(\"=\","),$1,q(","),$3,q(")"));} ;
	| expr4 NMGE expr5 {$$ = cat(5,q("Binop_(\">=\","),$1,q(","),$3,q(")"));} ;
	| expr4 NMGT expr5 {$$ = cat(5,q("Binop_(\">\","),$1,q(","),$3,q(")"));} ;
	| expr4 NMLE expr5 {$$ = cat(5,q("Binop_(\"<=\","),$1,q(","),$3,q(")"));} ;
	| expr4 NMLT expr5 {$$ = cat(5,q("Binop_(\"<\","),$1,q(","),$3,q(")"));} ;
	| expr4 NMNE expr5 {$$ = cat(5,q("Binop_(\"~=\","),$1,q(","),$3,q(")"));} ;
	| expr4 EQUIV expr5 {$$ = cat(5,q("Binop_(\"===\","),$1,q(","),$3,q(")"));} ;
	| expr4 NEQUIV expr5 {$$ = cat(5,q("Binop_(\"~===\","),$1,q(","),$3,q(")"));} ;

expr5	: expr6 ;
	| expr5 CONCAT expr6 {$$ = cat(5,q("Binop_(\"||\","),$1,q(","),$3,q(")"));} ;
	| expr5 LCONCAT expr6 {$$ = cat(5,q("Binop_(\"|||\","),$1,q(","),$3,q(")"));} ;

expr6	: expr7 ;
	| expr6 PLUS expr7 {$$ = cat(5,q("Binop_(\"+\","),$1,q(","),$3,q(")"));} ;
	| expr6 DIFF expr7 {$$ = cat(5,q("Binop_(\"--\","),$1,q(","),$3,q(")"));} ;
	| expr6 UNION expr7 {$$ = cat(5,q("Binop_(\"++\","),$1,q(","),$3,q(")"));} ;
	| expr6 MINUS expr7 {$$ = cat(5,q("Binop_(\"-\","),$1,q(","),$3,q(")"));} ;

expr7	: expr8 ;
	| expr7 STAR expr8 {$$ = cat(5,q("Binop_(\"*\","),$1,q(","),$3,q(")"));} ;
	| expr7 INTER expr8 {$$ = cat(5,q("Binop_(\"**\","),$1,q(","),$3,q(")"));} ;
	| expr7 SLASH expr8 {$$ = cat(5,q("Binop_(\"/\","),$1,q(","),$3,q(")"));} ;
	| expr7 MOD expr8 {$$ = cat(5,q("Binop_(\"%\","),$1,q(","),$3,q(")"));} ;

expr8	: expr9 ;
	| expr9 CARET expr8 {$$ = cat(5,q("Binop_(\"^\","),$1,q(","),$3,q(")"));} ;

expr9	: expr10 ;
	| expr9 BACKSLASH expr10 {$$ = cat(5,q("Limit_("),$1,q(","),$3,q(")"));} ;
	| expr9 AT expr10 {$$ = cat(5,q("Binop_(\"@\","),$1,q(","),$3,q(")"));};
	| expr9 BANG expr10 {$$ = cat(5,q("Apply_("),$1,q(","),$3,q(")"));};

expr10	: expr11 ;
	| AT expr10 {$$ = cat(3,q("Unop_(\"@\","),$2,q(")"));} ;
	| NOT expr10 {$$ = cat(3,q("Not_("),$2,q(")"));} ;
	| BAR expr10 {$$ = cat(3,q("Repalt_("),$2,q(")"));} ;
	| CONCAT expr10 {$$ = cat(2,$1,$2);} ;
	| LCONCAT expr10 {$$ = cat(2,$1,$2);} ;
	| DOT expr10 {$$ = cat(3,q("Unop_(\".\","),$2,q(")"));} ;
	| BANG expr10 {$$ = cat(3,q("Unop_(\"!\","),$2,q(")"));} ;
	| DIFF expr10 {$$ = cat(3,q("Unop_(\"--\","),$2,q(")"));} ;
	| PLUS expr10 {$$ = cat(3,q("Unop_(\"+\","),$2,q(")"));} ;
	| STAR expr10 {$$ = cat(3,q("Unop_(\"*\","),$2,q(")"));} ;
	| SLASH expr10 {$$ = cat(3,q("Unop_(\"/\","),$2,q(")"));} ;
	| CARET expr10 {$$ = cat(3,q("Unop_(\"^\","),$2,q(")"));} ;
	| INTER expr10 {$$ = cat(3,q("Unop_(\"**\","),$2,q(")"));} ;
	| TILDE expr10 {$$ = cat(3,q("Unop_(\"~\","),$2,q(")"));} ;
	| MINUS expr10 {$$ = cat(3,q("Unop_(\"-\","),$2,q(")"));} ;
	| NMEQ expr10 {$$ = cat(3,q("Unop_(\"=\","),$2,q(")"));} ;
	| NMNE expr10 {$$ = cat(3,q("Unop_(\"~=\","),$2,q(")"));} ;
	| SEQ expr10 {$$ = cat(3,q("Unop_(\"==\","),$2,q(")"));} ;
	| SNE expr10 {$$ = cat(3,q("Unop_(\"~==\","),$2,q(")"));} ;
	| EQUIV expr10 {$$ = cat(3,q("Unop_(\"===\","),$2,q(")"));} ;
	| UNION expr10 {$$ = cat(3,q("Unop_(\"++\","),$2,q(")"));} ;
	| QMARK expr10 {$$ = cat(3,q("Unop_(\"?\","),$2,q(")"));} ;
	| NEQUIV expr10 {$$ = cat(3,q("Unop_(\"~===\","),$2,q(")"));} ;
	| BACKSLASH expr10 {$$ = cat(3,q("Unop_(\"\\\\\","),$2,q(")"));} ;

expr11	: literal ;
	| section ;
	| return ;
	| if ;
	| case ;
	| while ;
	| until ;
	| every ;
	| repeat ;
	| CREATE expr {$$ = cat(3,q("Create_("),$2,q(")"));} ;
	| IDENT {$$ = cat(3,q("Var_(\""),$1,q("\")"));} ;
	| NEXT {$$ = q("Next_()");} ;
	| BREAK nexpr {$$ = cat(3,q("Break_("),$2,q(")"));} ;
	| LPAREN exprlist RPAREN {$$ = cat(3,q("Paren_("),$2,q(")"));} ;
	| LBRACE compound RBRACE {$$ = cat(3,q("Compound_("),$2,q(")"));} ;
	| LBRACK exprlist RBRACK {$$ = cat(3,q("List_("),$2,q(")"));} ;
	| expr11 LBRACK exprlist RBRACK {$$ = cat(5,q("Subscript_("),$1,q(","),$3,q(")"));} ;
	| expr11 LBRACE	RBRACE {$$ = cat(3,$1,$2,$3);} ;
	| expr11 LBRACE pdcolist RBRACE {$$ = cat(5,q("Pdco_("),$1,q(","),$3,q(")"));} ;
	| expr11 LPAREN exprlist RPAREN {$$ = cat(5,q("Invoke_("),$1,q(","),$3,q(")"));} ;
	| expr11 DOT IDENT {$$ = cat(5,q("Field_("),$1,q(",\""),$3,q("\")"));} ;
	| AND FAIL {$$ = q("Key_(\"fail\")");} ;
	| AND IDENT {$$ = cat(3,q("Key_(\""),$2,q("\")"));} ;

while	: WHILE expr {$$ = cat(3,q("While_("),$2,q(")"));} ;
	| WHILE expr DO expr {$$ = cat(5,q("While_Do_("),$2,q(","),$4,q(")"));} ;

until	: UNTIL expr {$$ = cat(3,q("Until_("),$2,q(")"));} ;
	| UNTIL expr DO expr {$$ = cat(5,q("Until_Do_("),$2,q(","),$4,q(")"));} ;

every	: EVERY expr {$$ = cat(3,q("Every_("),$2,q(")"));} ;
	| EVERY expr DO expr {$$ = cat(5,q("Every_Do_("),$2,q(","),$4,q(")"));} ;

repeat	: REPEAT expr {$$ = cat(3,q("Repeat_("),$2,q(")"));} ;

return	: FAIL {$$ = q("Fail_()");} ;
	| RETURN nexpr {$$ = cat(3,q("Return_("),$2,q(")"));} ;
	| SUSPEND nexpr {$$ = cat(3,q("Suspend_("),$2,q(")"));} ;
        | SUSPEND expr DO expr {$$ = cat(5,q("Suspend_Do_("),$2,q(","),$4,q(")"));};

if	: IF expr THEN expr {$$ = cat(5,q("If_("),$2,q(","),$4,q(")"));} ;
	| IF expr THEN expr ELSE expr {$$ = cat(7,q("If_Else_("),$2,q(","),$4,q(","),$6,q(")"));} ;

case	: CASE expr OF LBRACE caselist RBRACE {$$ = cat(5,q("Case_("),$2,q(","),$5,q(")"));} ;

caselist: cclause ;
	| caselist SEMICOL cclause {$$ = cat(5,q("Clist_("),$1,q(","),$3,q(")"));} ;

cclause	: DEFAULT COLON expr {$$ = cat(3,q("Default_("),$3,q(")"));} ;
	| expr COLON expr {$$ = cat(5,q("Cclause_("),$1,q(","),$3,q(")"));} ;

exprlist: nexpr                {$$ = $1;}
	| exprlist COMMA nexpr {$$ = cat(3,$1,$2,$3);} ;

pdcolist: nexpr {
		$$ = $1;
		} ;
	| pdcolist COMMA nexpr {
		$$ = cat(3,$1,$2,$3);
		} ;

literal	: INTLIT {$$ = cat(3,q("Ilit_("),$1,q(")"));} ;
	| REALLIT {$$ = cat(3,q("Rlit_("),$1,q(")"));} ;
	| STRINGLIT {$$ = cat(3,q("Slit_(\""),$1,q("\")"));} ;
	| CSETLIT {$$ = cat(3,q("Clit_('"),$1,q("')"));} ;

section	: expr11 LBRACK expr sectop expr RBRACK {$$ = cat(9,q("Section_(\""),$4,q("\","),$1,q(","),$3,q(","),$5,q(")"));} ;

sectop	: COLON {$$ = $1;} ;
	| PCOLON {$$ = $1;} ;
	| MCOLON {$$ = $1;} ;

compound: nexpr ;
	| nexpr SEMICOL compound {$$ = cat(3,$1,q(","),$3);} ;

program	: error decls EOFX ;
proc	: prochead error procbody END ;
expr	: error ;

%%

/*
 * xfree(p) -- used with free(p) macro to avoid compiler errors from
 *  miscast free calls generated by Yacc.
 */
static novalue xfree(p)
char *p;
{
   free(p);
}

#define free(p) xfree((char*)p)
